-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnLoad()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_OnLoad(self)

	self.registry = { 
		id = TITAN_PALS_ID,
		menuText = TITAN_PALS_MENU_TEXT, 
		buttonTextFunction = "TitanPanelPalsButton_GetButtonText", 
		tooltipTitle = TITAN_PALS_TOOLTIP,
		tooltipCustomFunction = TitanPanelPalsButton_SetTooltipText,
		icon = TITANPALS_ARTWORK_PATH.."TitanPals",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			ShowOffline = false,
			ShowIgnored = false,
			ShowClass = 1,
			ShowNote = false,
			MouseUpdate = 1,
			LoadMessage = 1,
			TitanUser = false,
			Debug = false,
		}
	};
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("FRIENDLIST_UPDATE");

	if DEFAULT_CHAT_FRAME and TitanGetVar(TITAN_PALS_ID, "LoadMessage") then
		DEFAULT_CHAT_FRAME:AddMessage("Titan Panel [Pals] v"..TITAN_PALS_VERSION.." loaded")
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_InitPalslist()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_InitPalslist()
	local TitanPals_InitPals = TitanGetVar(TITAN_PALS_ID, "TitanUser");
	if (not TitanPalsList) then TitanPalsList = {}; end
	if (not TitanPalsList[TitanPals_InitPals]) then TitanPalsList[TitanPals_InitPals] = {}; end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnEvent()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_OnEvent(self, event, ...)
	-- This line is for devlopment and will be remove
	-- for release versions 
	--------------------------------------------------
	TitanPals_Debug(event);
	--------------------------------------------------
	if (event == "PLAYER_ENTERING_WORLD") then
		local TPPN = UnitName("player");
		local TPPR = GetCVar("realmName");
		local TPPNA = TPPN.."@"..TPPR;
		TitanSetVar(TITAN_PALS_ID, "TitanUser", TPPNA);
		TitanPanelPals_InitPalslist()
		ShowFriends();
	end
	if (event == "FRIENDLIST_UPDATE") then
		TitanPanelButton_UpdateButton(TITAN_PALS_ID);
	end
	TitanPanelButton_UpdateButton(TITAN_PALS_ID);	
	TitanPanelButton_UpdateTooltip();
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnClick()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_OnClick(self, button)
	if (button == "LeftButton") then
		ToggleFriendsFrame(1);
	else
		TitanPanelButton_OnClick(self, button);
	end
end

-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PreparePalsMenu()
-- DESC : <research>
-- **************************************************************************
function TitanPanelRightClickMenu_PreparePalsMenu()
	local info = {};
	if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then

		-- this is for whispering a friend
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_WHISPER ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = palsWisper;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- this is for removing a friend from friends list
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_REMOVE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = PalsRemove;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for group Invites
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_INVITE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = PalsInvite;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for setting friends note
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_NOTE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = Pals_name;
					info.func = PalsNote;
					info.value = Pals_name
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end
		return;
	end

	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_PALS_ID].menuText);

	-- create the title for the Whisper submenu
	info = {};
	info.text = TITAN_PALS_MENU_WHISPER;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Invite submenu
	info = {};
	info.text = TITAN_PALS_MENU_INVITE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Ignore submenu
	info = {};
	info.text = TITAN_PALS_MENU_REMOVE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	-- create the title for the Note submenu
	info = {};
	info.text = TITAN_PALS_MENU_NOTE;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	-- ShowOffLine Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWOFFLINE;
	info.func = TitanPals_ShowOffline;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowOffline");
	UIDropDownMenu_AddButton(info);

	-- ShowIgnored Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWIGNORED;
	info.func = TitanPals_ShowIgnored;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowIgnored");
	UIDropDownMenu_AddButton(info);

	-- ShowClass Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWCLASS;
	info.func = TitanPals_ShowClass;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowClass");
	UIDropDownMenu_AddButton(info);

	-- ShowNote Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWNOTE;
	info.func = TitanPals_ShowNote;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowNote");
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	-- MouseUpdate Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_MOUSEUPDATE;
	info.func = TitanPals_MouseUpdate;
	info.checked = TitanGetVar(TITAN_PALS_ID, "MouseUpdate");
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_PALS_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_PALS_ID);

	-- default Titan Panel right-click menu options
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_PALS_ID, TITAN_PANEL_MENU_FUNC_HIDE);

end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_GetButtonText()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_GetButtonText(id)
	local id = TitanUtils_GetButton(id, true);
	local NumPals = GetNumFriends();
	local NumIgnore = GetNumIgnores();
	local NumPalsOnline = 0;

	local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected
	local friendIndex

	-- get a count of the number of online friends
	for friendIndex=1, NumPals do
		Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected = GetFriendInfo(friendIndex);
		if ( Pals_connected ) then
			NumPalsOnline = NumPalsOnline + 1;
		end
	end

	-- create string for Titan bar display
	local buttonRichText = format(TITAN_PALS_BUTTON_TEXT, TitanUtils_GetGreenText(NumPalsOnline), TitanUtils_GetHighlightText(NumPals), TitanUtils_GetRedText(NumIgnore));
	return TITAN_PALS_BUTTON_LABEL, buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelPals_PopulateName()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_PopulateName(status, level, class, name)		
		local colorCode = "";
		if (status) then status = status.." "; end;

		if (class == "Warlock") then colorCode = "|cff9482C9";
		elseif (class == "DeathKnight") then colorCode = '|cffc41f3b';
		elseif (class == "Hunter") then colorCode = "|cffabd473";
		elseif (class == "Priest") then colorCode = "|cffffffff";
		elseif (class == "Paladin") then colorCode = "|cfff58cba";
		elseif (class == "Mage") then colorCode = "|cff69ccf0";
		elseif (class == "Rogue") then colorCode = "|cfffff569";
		elseif (class == "Druid") then colorCode = "|cffff7d0a";
		elseif (class == "Shaman") then colorCode = "|cff2459FF";
		else colorCode = "|cffc79c6e";
		end
		if (level == 0) then level = "-"; end
		if ( TitanGetVar(TITAN_PALS_ID, "ShowClass") ) then
			return "  "..status.." ("..TitanUtils_GetHighlightText(level).." "..colorCode..class..FONT_COLOR_CODE_CLOSE..") "..TitanUtils_GetNormalText(name)..FONT_COLOR_CODE_CLOSE;
		else
			return "  "..status.."("..TitanUtils_GetHighlightText(level)..") "..colorCode..name..FONT_COLOR_CODE_CLOSE;
		end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_SetTooltipText()
	if ( TitanGetVar(TITAN_PALS_ID, "MouseUpdate") ) then
		ShowFriends();
	end;
	GameTooltip:SetText(TITAN_PALS_TOOLTIP, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	local NumPals = GetNumFriends();
	local OnlinePals = 0;
	local OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note
	local OnlinefriendIndex
	local TitanPalsUser = TitanGetVar(TITAN_PALS_ID, "TitanUser")
	if ( NumPals == 0 ) then GameTooltip:AddLine("Your Pals List Is Currently Empty!!!")
		else for OnlinefriendIndex=1, NumPals do
			OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note = GetFriendInfo(OnlinefriendIndex);
			local TitanPals_ColoredNamePlate, TitanPals_AreaInfo
 			if ( not TitanPalsList[TitanPalsUser][OnlinePals_name] ) then 
				TitanPanelPals_AddPals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note); 
			end
			if ( OnlinePals_connected ) then
				TitanPanelPals_UpdatePals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note);
				TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OnlinePals_status, OnlinePals_level, OnlinePals_class, OnlinePals_name);
				TitanPals_AreaInfo = TitanUtils_GetHighlightText(OnlinePals_area)
				OnlinePals = OnlinePals + 1;
				if ( TitanGetVar(TITAN_PALS_ID, "ShowNote") ) then
					if ( OnlinePals_note ) then
						OnlinePals_note = "("..OnlinePals_note..")"
						TitanPals_AreaInfo = TitanUtils_GetNormalText(OnlinePals_note).." "..TitanPals_AreaInfo
					end
				end
			end
			GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanUtils_GetHighlightText(TitanPals_AreaInfo));
		end
		if ( OnlinePals == 0 ) then 
			GameTooltip:AddLine("No Pals Currently Online"); 
		end
	end
	if ( TitanGetVar(TITAN_PALS_ID, "ShowOffline") ) then
		GameTooltip:AddLine("\n");
		GameTooltip:AddLine(TitanUtils_GetHighlightText(TITAN_PALS_TOOLTIP_OFF));

		local OfflinefriendIndex
		for OfflinefriendIndex=1, NumPals do
			OfflinePals_name, OfflinePals_level, OfflinePals_class, OfflinePals_area, OfflinePals_connected, OfflinePals_status, OfflinePals_note = GetFriendInfo(OfflinefriendIndex);
			OfflinePals_level = TitanPalsList[TitanPalsUser][OfflinePals_name].level
			OfflinePals_class = TitanPalsList[TitanPalsUser][OfflinePals_name].class
			OfflinePals_note = TitanPalsList[TitanPalsUser][OfflinePals_name].note
			TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OfflinePals_status, OfflinePals_level, OfflinePals_class, OfflinePals_name)
			TitanPals_AreaInfo = "<Offline>"
			if ( TitanGetVar(TITAN_PALS_ID, "ShowNote") ) then
				if ( OfflinePals_note ) then
					TitanPals_AreaInfo = "("..OfflinePals_note..")"..TitanPals_AreaInfo 
				end
			end
 			if ( not OfflinePals_connected ) then GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, GRAY_FONT_COLOR_CODE.."<Offline>"..FONT_COLOR_CODE_CLOSE); end
		end
	end
	if ( TitanGetVar(TITAN_PALS_ID, "ShowIgnored") ) then
		GameTooltip:AddLine("\n");
		GameTooltip:AddLine(TitanUtils_GetHighlightText(TITAN_PALS_TOOLTIP_IGNORED));
		Numignored = GetNumIgnores();
		local ignoredIndex

		if (Numignored == 0) then GameTooltip:AddLine("Your ignore list is currently empty.");
			else for ignoredIndex=1, Numignored do
				if (not OfflinePals_connected ) then
					local TitanPals_IgnoredTxt =  TitanUtils_GetRedText("<Ignored>")
					GameTooltip:AddDoubleLine("  "..TitanUtils_GetNormalText(GetIgnoreName(ignoredIndex)), TitanPals_IgnoredTxt);
				end
			end
		end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_UpdatePals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_AddPals(name, level, class, area, note)
	local TitanPalsAddUser = TitanGetVar(TITAN_PALS_ID, "TitanUser")
	if ( not TitanPalsList[TitanPalsAddUser][name] ) then 
		TitanPalsList[TitanPalsAddUser][name] = {};
		TitanPalsList[TitanPalsAddUser][name].level = level;
		TitanPalsList[TitanPalsAddUser][name].class = class;
		TitanPalsList[TitanPalsAddUser][name].area = area;
		if ( note ) then TitanPalsList[TitanPalsAddUser][name].note = note; end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_UpdatePals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_UpdatePals(name, level, class, area, note)
	local TitanPalsUpdateUser = TitanGetVar(TITAN_PALS_ID, "TitanUser");
	if (level) then TitanPalsList[TitanPalsUpdateUser][name].level = level; end
	if (class) then TitanPalsList[TitanPalsUpdateUser][name].class = class; end
	if (area) then TitanPalsList[TitanPalsUpdateUser][name].area = area; end
	if (note) then TitanPalsList[TitanPalsUpdateUser][name].note = note; end
end

-- **************************************************************************
-- NAME : TitanPals_ShowOffline()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowOffline()
   TitanToggleVar(TITAN_PALS_ID, "ShowOffline");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowIgnored()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowIgnored()
   TitanToggleVar(TITAN_PALS_ID, "ShowIgnored");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowClass()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowClass()
   TitanToggleVar(TITAN_PALS_ID, "ShowClass");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_MouseUpdate()
-- DESC : <research>
-- **************************************************************************
function TitanPals_MouseUpdate()
   TitanToggleVar(TITAN_PALS_ID, "MouseUpdate");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowNote()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowNote()
   TitanToggleVar(TITAN_PALS_ID, "ShowNote");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : PalsRemove()
-- DESC : <research>
-- **************************************************************************
function PalsRemove()
	local IgnoreRemove = this.value;
	RemoveFriend( this.value );
end

-- **************************************************************************
-- NAME : PalsInvite()
-- DESC : <research>
-- **************************************************************************
function PalsInvite()
	InviteUnit( this.value );
end

-- **************************************************************************
-- NAME : PalsNote()
-- DESC : <research>
-- **************************************************************************
function PalsNote()
-- this will be for setting a friends note
end

-- **************************************************************************
-- NAME : palsWisper()
-- DESC : <research>
-- **************************************************************************
function palsWisper()
	if ( not ChatFrameEditBox:IsVisible() ) then
		ChatFrame_OpenChat("/w "..this.value.." ");
	else
		ChatFrameEditBox:SetText("/w "..this.value.." ");
	end
end

--------------------------------------------------------------------------
-- NAME : TitanPals_Debug();
-- DESC : </script TitanSetVar(TITAN_PALS_ID,"Debug",1)>
--------------------------------------------------------------------------
function TitanPals_Debug(msg)
	if TitanGetVar(TITAN_PALS_ID, "Debug") then
		DEFAULT_CHAT_FRAME:AddMessage("Titan[|cffeda55fPals|r] Debug: "..msg)
	end
end

-- **************************************************************************
-- NAME : TitanPals_FixList()
-- DESC : <research>
-- **************************************************************************
function TitanPals_FixList(name, class, level)
	local FixListUser = TitanGetVar(TITAN_PALS_ID, "TitanUser")
	TitanPalsList[FixListUser][name].level = level
	TitanPalsList[FixListUser][name].class = class
end
